###################################################
### Adatok s fggvnyek beolvassa.
### (A leiro.stat() fggvnyhez szksges a gdata 
### knyvtr!)
###################################################
lepke = read.table("lepke.txt",header=T)
source("leiro.stat.R")
source("errorbars.R")

###################################################
### 339. oldal 
###################################################
lepke[1:5,]

###################################################
### 339. oldal 
###################################################
with(lepke,leiro.stat(BABTOMEG,TAP,HOM))

###################################################
### 340. oldal, 11.1. bra 
###################################################
with(lepke,boxplot(BABTOMEG~TAP:HOM, xlab="Kezelsi csoportok",
ylab="Bbtmeg (g)",names=c("AH","LH","AM","LM","AS","LS")))

###################################################
### 340. oldal; 341. oldal, 11.2. bra 
###################################################
with(lepke,errorbars(BABTOMEG,HOM,TAP, error.bars="sd",main="",
xlab="Hmrskleti kezels", ylab="Bbtmeg (g; tlag s SD)",
legend.lab="Tpllk",levs2=c("ad libitum", "limitlt"),
levs=c("Httt","Melegtett","Szobah"), col=c(1,1),lty=c(1,1),
x.posn=1.2,y.posn=0.37,))

###################################################
### 341. oldal; 342. oldal 11.3. bra 
###################################################
with(lepke,interaction.plot(HOM,TAP,BABTOMEG,
xlab="Hmrskleti kezels", ylab="Bbtmeg (g; tlag)",
trace.label="", xaxt="n",legend=F,ylim=c(0.17,0.33)))
legend(2.5,0.28,lty=1:2,legend=c("ad libitum", "limitlt"),
bty="n",title="Tpllk")
axis(1,at=1:3,labels=c("Httt","Melegtett","Szobah"))

###################################################
### 341. oldal; 342. oldal, 11.4. bra 
###################################################
with(lepke,boxplot(TOMEG0~TAP:HOM,
names=c("AH","LH","AM","LM","AS","LS"),
xlab="Kezelsi csoportok",
ylab="Kezdeti hernytmeg (g)"))

###################################################
### 342. oldal; 343. oldal 11.5. bra
###################################################
with(lepke,coplot(BABTOMEG~TOMEG0|TAP*HOM, las=0,
xlab=c("Kezdeti hernytmeg (g)"
,"Tpllkkezels"), ylab=c("Bbtmeg (g)",
paste("H mrskleti kezels"))))

###################################################
### 350-351. oldal, 11.1. plda
###################################################
(lmmod1 = lm(BABTOMEG~HOM,data=lepke))

(lmmod2 = lm(BABTOMEG~HOM-1,data=lepke))

###################################################
### 351-352. oldal, 11.2. plda
###################################################
(lmmod3a = lm(BABTOMEG~TAP+HOM,data=lepke))

(lmmod3b = lm(BABTOMEG~TAP+HOM-1,data=lepke))

###################################################
### 352-353. oldal, 11.3. plda
###################################################
(lmmod4 = lm(BABTOMEG~TAP+HOM+TAP:HOM,data=lepke))

(lmmod5 = lm(BABTOMEG~TAP:HOM-1,data=lepke))

###################################################
### 353-354. oldal, 11.4. plda, 11.7. bra
###################################################
(lmmod6 = lm(BABTOMEG~TOMEG0+TAP,data=lepke))

(lmmod7 = lm(BABTOMEG~TOMEG0+TAP-1,data=lepke))

with(lepke,plot(BABTOMEG~TOMEG0,pch=as.numeric(TAP),
xlab="Kezdeti hernytmeg (g)", ylab="Bbtmeg (g)"))
legend(0.05,0.3,pch=1:2,lty=1:2,title="Tpllk",
legend=c("ad libitum","limitlt"),bty="n")
abline(coef(lmmod7)[[2]],coef(lmmod7)[[1]])
abline(coef(lmmod7)[[3]],coef(lmmod7)[[1]],lty=2)

###################################################
### 355. oldal, 11.5. plda, 356. oldal, 11.8. bra
###################################################
(lmmod8 = lm(BABTOMEG~TOMEG0*TAP,data=lepke))

(lmmod9 = lm(BABTOMEG~TOMEG0:TAP+TAP-1,data=lepke))

with(lepke,plot(BABTOMEG~TOMEG0,pch=as.numeric(TAP),
xlab="Kezdeti hernytmeg (g)", ylab="Bbtmeg (g)"))
legend(0.05,0.3,pch=1:2,lty=1:2,title="Tpllk",
legend=c("ad libitum","limitlt"),bty="n")
abline(coef(lmmod9)[[1]],coef(lmmod9)[[3]])
abline(coef(lmmod9)[[2]],coef(lmmod9)[[4]],lty=2)

###################################################
### 357. oldal, 11.6. plda
###################################################
str(lepke)

###################################################
### 362-363. oldal, 11.7. plda
###################################################
teljesmod = lm(BABTOMEG~TOMEG0*TAP*HOM,data=lepke)
summary(teljesmod)

nullmod = lm(BABTOMEG~1,data=lepke)
anova(teljesmod,nullmod)

###################################################
### 363. oldal, 11.8. plda 
###################################################
teljesmod = lm(BABTOMEG~TOMEG0*TAP*HOM,data=lepke)
anova(teljesmod)

###################################################
### 364. oldal, 11.9. plda
###################################################
teljesmod = lm(BABTOMEG~TOMEG0*TAP*HOM,data=lepke)
reszmod = lm(BABTOMEG~TOMEG0*TAP,data=lepke)
anova(teljesmod,reszmod)

###################################################
### 365. oldal, 11.10. plda
###################################################
lmmod10 = lm(BABTOMEG~TOMEG0+TAP*HOM,data=lepke)
confint(lmmod10)

lmmod11 = lm(BABTOMEG~TOMEG0+TAP:HOM-1,data=lepke)
confint(lmmod11)

###################################################
### 366. oldal, 11.11. plda; 367. oldal, 11.11. bra
###################################################
redmod = lm(BABTOMEG~TOMEG0*TAP,data=lepke)
par (mfrow=c(2,2))
plot(redmod)
par(mfrow=c(1,1))

###################################################
### 367-368. oldal, 11.12. plda; 369. oldal, 11.12. bra
###################################################
oz = read.table("oz.csv",sep=";",header=T)
ozmod = lm(TOMEG~SEX+TESTH,data=oz)
anova(ozmod)
plot(ozmod,1,pch=20)

oz$TESTHfaktor = cut(oz$TESTH,breaks=c(50,80,110,130),
labels=c("kicsi","kzepes","nagy"))
ozmodkat = lm(TOMEG~SEX+TESTH+TESTHfaktor,data=oz)
anova(ozmodkat)
plot(ozmodkat,1,pch=20)

###################################################
### 372-373. oldal, 11.13. plda 
###################################################
lmmod14 = lm(BABTOMEG~TOMEG0*TAP,data=lepke)
lmmod15 = lm(BABTOMEG~TOMEG0:TAP+TAP-1,data=lepke)
lmmod3 = lm(BABTOMEG~TOMEG0+TAP,data=lepke)

extractAIC(lmmod14)
extractAIC(lmmod15)
extractAIC(lmmod3)

(BICmod14 = extractAIC(lmmod14, k=log(nrow(lepke))))
(BICmod15 = extractAIC(lmmod15, k=log(nrow(lepke))))
(BICmod3 = extractAIC(lmmod3, k=log(nrow(lepke))))

anova(lmmod14,lmmod3)

###################################################
### 374-375. oldal, 11.14. plda
###################################################
teljesmod = lm(BABTOMEG~TOMEG0*TAP*HOM,data=lepke)
(redmod = step(teljesmod,trace=0))
anova(teljesmod,redmod)

drop1(teljesmod,test="F")

###################################################
### 377-379. oldal, 11.15. plda 
###################################################
magassag = c(60, 58, 65, 64, 57, 55, 57, 58, 54, 46, 50, 48,
62, 57, 60, 61, 55, 54, 52, 60, 45, 44, 42, 48)
tapoldat = rep(rep(c("tomeny","hig","viz"),rep(4,3)),2)
fajta = rep(1:2,rep(12,2))
fajta = factor(fajta)
adat = data.frame(fajta,tapoldat,magassag)

tapmod1 = lm(magassag~tapoldat+fajta,data=adat)
anova(tapmod1)

adat$tapoldat = relevel(adat$tapoldat,ref="viz")
tapmod2 = lm(magassag~tapoldat+fajta,data=adat)

library(multcomp)
confint(glht(tapmod2,linfct=mcp(tapoldat="Dunnett")))
summary(glht(tapmod2,linfct=mcp(tapoldat="Dunnett")))

confint(glht(tapmod1,linfct=mcp(tapoldat="Tukey")))
summary(glht(tapmod1,linfct=mcp(tapoldat="Tukey")))

###################################################
### Adatok s fggvnyek betltse
###################################################
lile = read.table("lilemeret.txt",header=T,sep=";")
source("errorbars.r")
source("leiro.stat.r")

###################################################
### 381-382. oldal, 11.16. plda, 11.13. bra
###################################################
with(lile,errorbars(tomeg,hely,ivar,error.bars="sd",
main="",levs2=c("Hm","Toj"),ylab="tmeg (g, tlag  SD)",
col=c(1,1),lty=c(1,3),x.posn=2.8))

with(lile,plot(tomeg~jszarny,pch=20, 
xlab="jobb szrny hossza (mm)",ylab="tmeg (g)"))

with(lile,leiro.stat(tomeg,hely,ivar))

###################################################
### 383. oldal, 11.17. plda; 384. oldal, 11.14. bra
###################################################
lilemod = lm(tomeg~jszarny*hely+ivar,data=lile)
anova(lilemod)

par (mfrow=c(2,2))
plot(lilemod)
par(mfrow=c(1,1))


###################################################
### 383-386. oldal, 11.18. plda, 
### 387. oldal, 11.15. bra
###################################################
(mod1 = lm(tomeg~hely+ivar,data=lile))

Kontmat1 = matrix(0,3,4,dimnames=list(c("B","C","D"),
c("(Intercept)", "helyC", "helyD", "ivarT")))
Kontmat1[1,]=c(1,0,0,1/2)
Kontmat1[2,]=c(1,1,0,1/2)
Kontmat1[3,]=c(1,0,1,1/2)
Kontmat1

library(gmodels)
(estmod1 = estimable(mod1,Kontmat1,conf.int=.95))
estmod1[, c(1, 2, 6, 7)]

(mod2 = lm(tomeg~hely+ivar-1,data=lile))

Kontmat2 = matrix(0,3,4,dimnames=list(c("B","C","D"),
c("helyB", "helyC", "helyD", "ivarT")))
Kontmat2[1,]=c(1,0,0,1/2)
Kontmat2[2,]=c(0,1,0,1/2)
Kontmat2[3,]=c(0,0,1,1/2)

(estmod2 = estimable(mod2,Kontmat2,conf.int=.95))

library(gplots)
plotCI(estmod2[,1],uiw=estmod2[,7]-estmod2[,1],
xlim=c(0,4),xaxt="n",
bty="l",ylab="tlagbecslsek s konfidencia-intervallumok",
xlab="Helyek",ylim=c(37,43))
axis(side=1, at=1:3, labels=c("B","C","D"), cex=0.7)


###################################################
### 386-387. oldal, 1.19. plda
###################################################
Kontmat3 = matrix(0,3,4,dimnames=list(c("C-B","D-B","C-D"),
c("helyB", "helyC", "helyD", "ivarT")))

Kontmat3[1,]=c(-1,1,0,0)
Kontmat3[2,]=c(-1,0,1,0)
Kontmat3[3,]=c(0,1,-1,0)

(estmod3 = estimable(mod2,Kontmat3,conf.int=.95))

p.adjust(estmod3[,5], method = c("fdr"))

source("tk.adjust.r")
tk.adjust(estmod3[, c(1, 2, 4)])

tk.adjust(estmod3[, c(1, 2, 4)], conf.int = 0.95)
cbind(estmod3[, c(1, 2)], tk.adjust(estmod3[, c(1, 2, 4)], 
conf.int = 0.95))

###################################################
### 388. oldal, 11.20. plda 
###################################################
(mod4 = lm(tomeg~hely+ivar+jszarny-1,data=lile))

atlagJszarny = mean(lile$jszarny)

Kontmat4 = matrix(0,3,5,dimnames=list(c("B","C","D"),
c("helyB", "helyC", "helyD", "ivarT", "jszarny")))
Kontmat4[1,]=c(1,0,0,1/2,atlagJszarny)
Kontmat4[2,]=c(0,1,0,1/2,atlagJszarny)
Kontmat4[3,]=c(0,0,1,1/2,atlagJszarny)

(estmod4 = estimable(mod4,Kontmat4,conf.lev=.95))

###################################################
### 388-389. oldal, 11.21. plda
###################################################
mod5 = lm(tomeg~hely:ivar-1+jszarny,data=lile)
ci(mod5)

(mod6 = lm(tomeg~hely+ivar+hely:jszarny-1,data=lile))

Kontmat6 = matrix(0,3,7,dimnames=list(c("B","C","D"),
c("helyB", "helyC", "helyD", "ivarT", "helyB:jszarny",
"helyC:jszarny", "helyD:jszarny" )))
Kontmat6[1,]=c(1,0,0,1/2,100,0,0)
Kontmat6[2,]=c(0,1,0,1/2,0,100,0)
Kontmat6[3,]=c(0,0,1,1/2,0,0,100)

(estmod6 = estimable(mod6,Kontmat6,conf.lev=.95))

Kontmat7 = matrix(0,3,7,dimnames=list(c("C-B","D-B","D-C"),
c("helyB", "helyC", "helyD", "ivarT", "helyB:jszarny",
"helyC:jszarny", "helyD:jszarny" )))
Kontmat7[1,]=c(-1,1,0,0,-100,100,0)
Kontmat7[2,]=c(-1,0,1,0,-100,0,100)
Kontmat7[3,]=c(0,-1,1,0,0,-100,100)

(estmod7 = estimable(mod6,Kontmat7,conf.lev=.95))

###################################################
### 390. oldal, 11.22. plda
###################################################

> Kontmat8 = matrix(0, 3, 7, dimnames = list(c("C-B", "D-B", "D-C"), c("helyB", "helyC", "helyD", "ivarT",
"helyB:jszarny", "helyC:jszarny", "helyD:jszarny")))
Kontmat8[1, ] = c(0, 0, 0, 0, -1, 1, 0)
Kontmat8[2, ] = c(0, 0, 0, 0, -1, 0, 1)
Kontmat8[3, ] = c(0, 0, 0, 0, 0, -1, 1)
(estmod8 = estimable(mod6, Kontmat8, conf.lev = 0.95))








